c -*- Fortran -*-

c common block holding all required parameters
      
      logical intflg

c simulation parameters:
c ict, ictpres, lmo, akmax0, akmaxt, nlnkt:

      integer p_ict
      integer p_prc
      integer p_lmx
      real    p_emx
      real    p_kmx
      integer p_nkl

c transfer-function parameters:
c ntf, ztf, filenames:

      integer p_ntf
      real    p_ztf(10)
      character*80 p_ftf(10)

c cosmological parameters:
c omegab,omegac,omegav,omegan,h0,tcmb,yhe,annur,annunr:

cDE   p_par arguments increased for effective dark energy present and 
cDE   asimptotic equation of state, scalar field dark energy density and 
cDE   equation of state
      real    p_par(13)                                          !DE10
cDE   pot_par arguments contain potential index ipot (inverse power law (ipot=1), SUGRA (ipot=2), potential exponent alpha 
cDE   and amplitude amplipot, present field value phif0 and initial kinetic versus potential energy ratio rkinpot 
cDE   are automatically assigned in driver)
      real    pot_par(1)                                         !DE20
      integer ipot                                               !DE
cDE   nmc_par arguments are coupling index inmc, Jordan Brans Dicke parameter omegaJBD, 
cDE   sign of coupling constant signJBD (potential coupling (inmc=1) betanmc and coupling constant cnmc
cDE   are automatically assigned in driver)
      real    nmc_par(3)                                         !DE30
      integer inmc                                               !DE
      real    omegaJBD,signJBD                                   !DE

c recombination parameter:
c rcflag

      integer p_rcf

c reionization parameters:
c riflag, optdlss, zri, rif:

      real    p_rif
      real    p_opd
      real    p_red
      real    p_frc

c mode specifications:
c itflag, nn, an, itn, ant, irt, rat:

      integer p_tfl
      integer p_nsm
      real    p_scl(10)
      integer p_itn
      real    p_ten(10)
      integer p_irt
      real    p_rat(10)

c lensing:
c lensflag, filename for scalar C_l, filename for lensed scalar C_l,
c filejlens:

      integer p_glf
      character*80 p_fcl
      character*80 p_fgl
      character*80 p_jgl

c filename for tensor C_l:

      character*80 p_tcl

c initial-condition flag:

      integer p_inf

c filenames for j_l and u_jl:

      character*80 p_fjl
      character*80 p_ujl

c filename for FITS output:

      character*80 p_fts

      common /cmbpar/
     &     p_ict,p_prc,p_lmx,p_emx,p_kmx,p_nkl,p_ntf,p_ztf,
     &     p_ftf,p_par,p_rif,p_opd,p_red,p_frc,p_tfl,p_nsm,
     &     p_scl,p_itn,p_ten,p_irt,p_rat,p_glf,p_fcl,p_fgl,
     &     p_jgl,p_tcl,p_inf,p_fjl,p_ujl,p_fts,p_rcf,intflg

      save /cmbpar/

c end of parameter specification
