ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cDE   this routine selects the correct tracking trajectory for scalar field dark energy
      subroutine fieldini(age,phifb,phifdotb,phife,phifdote,
     &  agegyr,abeg,aend)                                           !DE
      implicit double precision (a-h, o-z)                          !DE
      parameter (neqn=4)                                            !DE
      character*80 filebkg,fileprt                                  !DE

      common /filenames/ filebkg,fileprt                            !DE

cDE   common lingerinc now contains: 
cDE   effective dark energy present and asimptotic equation of state wv, wvbeg, 
cDE   scalar field dark energy density parameter and equation of state today, omegaphif, wphif
      common /lingerinc/ omegab,omegac,omegav,wv,wvbeg,omegan
     &  ,omegak,h0,tcmb,yhe,annur,annunr,omegaphif,wphif            !DE
cDE   common potpar and ggrpar with scalar field dark energy potential parameters
      common /potpar/ alphapot,amplipot,phif0,rkinpot,ipot          !DE
      common /ggrpar/ betanmc,cnmc,omgjbd,sgnjbd,inmc               !DE

      common /genparm/ grhom,grhog,grhor,adotrad,taurst,dtaurec     !DE
      dimension y(4), yprime(4),work(neqn*6+3), iwork(5)            !DE
cDE   y(1)=a,y(2)=phi,y(3)=phifdot,y(4)= t (Gyr, ordinary time)     
cDE   these externals define potential and its derivative, 
cDE   non-minimal coupling function, generalised kinetic 
cDE   term function
      external potential,potentialprime,potentialsecond             !DE
      external fnmc,delta_fnmc,fnmcprime,fnmcsecond,fnmcthird       !DE
      external onmc,onmcprime,onmcsecond                            !DE
cDE   these externals define cosmological equations in scalar-tensor 
cDE   cosmologies 
      external ekgderivsbnmc                                        !DE
      pi=dacos(-1.d0)                                               !DE
cDE   initial values for bisection
      if(ipot.eq.1)then                         !DE if on ipot
cDE   in typical tracking inverse power law trakectories, final phif 
cDE   is of the order of the Planck mass and initial phif much smaller; 
cDE   setting phi=1.e-3 Planck masses initially
      phifbeg=1.d-5						    !DE
cDE   redefines potential exponent according to tracking regime
      alphapot=(2.d0+2.d0*wphif)/wphif                              !DE
      damplipot=1.d-1			        !DE bbt: initial differential potential amplitude step
      dalphapot=1.d-1				!DE btt: initial differential potential exponent step
      signold=1.d0				!DE btt: initial potential exponent increment sign
      signoldeos=1.d0				!DE btt: initial equation of state increment sign
      else if(ipot.eq.2)then                    !DE if on ipot
cDE   in typical tracking SUGRA trakectories, final phif 
cDE   is of the order of the Planck mass and initial phif much smaller; 
cDE   setting phi=1.e-3 Planck masses initially
      phifbeg=1.d-3				                    !DE
cDE   redefines potential exponent according to tracking regime
      alphapot=-11.5d0*((wphif+0.99d0)/(0.99d0-0.82d0))**3.75d0     !DE
      damplipot=1.d-1			        !DE bbt: initial differential potential amplitude step
      dalphapot=1.d-1				!DE btt: initial differential potential exponent step
      signold=1.d0				!DE btt: initial potential exponent increment sign
      signoldeos=1.d0				!DE btt: initial equation of state increment sign
      end if                                    !DE end if on ipot
      phifdown=phifbeg				!DE Bisection Tracking Trajectory (btt): lower initial field value
      phifup=phifbeg				!DE btt: upper initial field value
369   phiftest=(phifdown+phifup)/2.d0 	        !DE btt: initial fiducial value
      taubeg=abeg/adotrad                       !DE btt: initial tau
      y(1)=abeg                                 !DE btt: initial value for a 
      y(2)=phiftest                             !DE btt: initial fiducial value
      phifdottest=abeg*dsqrt(rkinpot*2.d0*potential(y(2))/onmc(y(2)))                                   !DE
      y(3)=phifdottest                                     !DE btt: initial conformal time field derivative
      y(4)=0.d0                                            !DE btt: conformal time
      iwri=0                                               !DE filebkg writing index
      open(unit=1, file=filebkg, status='unknown')         !DE
cDE   iflag is an integration check parameter, to be set 1 initially: if integration goes ok, it is set to 2
      iflag=1                                              !DE
      xin=taubeg                                           !DE
      xout=xin                                             !DE
cDE   now calling rkf45: it needs routine derivatives name, number of differential equations, y vector, 
cDE   initial and final times; this is the first call in which derivatives are defined and no integration is done, 
      call rkf45(ekgderivsbnmc,neqn,y,xin,xout,1.d-10,1.d-10,
     &  iflag,work,iwork)                                  !DE
      if(iflag.ne.2) print*,'Problem in rkf45, 
     &  first call in fieldini, iflag:',iflag              !DE
      signadiffold=-1.d0                                   !DE btt: initial scale factor increment sign
      steptau=5.d1                                         !DE  
83    	      if(iwri.eq.0)then                            !DE sample only if writes
		      if(xin.le.1.d1)then 	           !DE sample differently at very high redshifts
		      steptau=.01d0*xin	                   !DE
		      else if(xin.le.1.d2)then             !DE
		      steptau=.1d0*xin                     !DE
		      else                                 !DE
		      steptau=5.d1		           !DE
		      end if		                   !DE
	      end if			                   !DE
cDE   now calling rkf45 to integrate forward in time
      xout=xin+steptau                                     !DE 
      iflag=1                                              !DE
      call rkf45(ekgderivsbnmc,neqn,y,xin,xout,1.d-10,1.d-10,
     &  iflag,work,iwork)                                  !DE
      if(iflag.ne.2) print*,'Problem in rkf45, 
     &  second call in fieldini, iflag:',iflag                                                 !DE
	      if(y(1).lt.1.0d-9) then                                                          !DE
	      rhonu=1.0d0                                                                      !DE
	      pnu=1.d0/3.d0                                                                    !DE
	      else                                                                             !DE
	      call nu1(y(1),rhonu,pnu)                                                         !DE
	      end if                                                                           !DE
cDE   calculating dtauda: for scalar-tensor cosmologies, writing a second order equation for adotoa
	      if(inmc.ne.0)then                                                                !DE
      abgnmc=1.d0                                                                              !DE
      bbgnmc=fnmcprime(y(2))*y(3)/fnmc(y(2))                                                   !DE
      cbgnmc=(grhom*(omegab+omegac)/y(1)+
     &  (grhog+grhor*(annur+annunr*rhonu))/y(1)**2.d0)/
     &  8.d0/pi+grhom*omegav*
     &  y(1)**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))*
     &  y(1)**2.d0*fnmc(y(2))+
     &	potential(y(2))*y(1)**2.d0+onmc(y(2))/2.d0*y(3)**2                                         !DE
      cbgnmc=-cbgnmc/(fnmc(y(2))*3.d0)                                                             !DE
      discriminante=bbgnmc**2-4.d0*abgnmc*cbgnmc                                                   !DE
		      if(discriminante.lt.0.d0) print*,'problems with the 
     &  generalized Einstein equation, first dtauda in fieldini'                                   !DE
      adotoa=(-bbgnmc+dsqrt(discriminante))/(2.d0*abgnmc) !DE note positive solution since we want adotoa > 0
	      else                                                                                 !DE
      adotoa=dsqrt((grhom*(omegac+omegab)/y(1)+(grhog+grhor*
     &  (annur+annunr*rhonu))/y(1)/y(1)+grhom*
     &  omegav*
     &  y(1)**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))*
     &  y(1)*y(1)+
     &	8.d0*pi*(onmc(y(2))/2.d0*y(3)**2.d0+
     &  potential(y(2))*y(1)*y(1)))/3.0d0)                                                         !DE
 	     end if                                          !DE end if on inmc for dtauda calculation
      dadtau=adotoa*y(1)                                                               !DE
      dtauda=1.d0/dadtau                                                               !DE
cDE   Klein Gordon needed now
      grhomatter=(grhom*(omegab+omegac)/y(1)+
     &  (grhog+grhor*(annur+annunr*rhonu))/y(1)**2)/8.d0/pi                            !DE
      grhomattermatter=grhom*(omegab+omegac)/y(1)/8.d0/pi                              !DE
      grhomatterradiation=(grhog+grhor*(annur+annunr*rhonu))/
     &  y(1)**2/8.d0/pi                                                                !DE
      gpresmatter=((grhog+grhor*annur)/3.0d0+grhor*annunr*pnu)/
     &  y(1)**2/8.d0/pi                                                                !DE
	      if(inmc.ne.0)then                                                        !DE
      akgnmc=1.5d0*fnmcprime(y(2))**2                                                  !DE
      akgnmc=1.d0+akgnmc/fnmc(y(2))/onmc(y(2))                                         !DE
      bkgnmc=1.5d0*fnmcprime(y(2))**2                                                  !DE
      bkgnmc=2.d0*adotoa*(1.d0+bkgnmc/fnmc(y(2))/onmc(y(2)))                           !DE
      ckgnmc=1.5d0*fnmcprime(y(2))*fnmcsecond(y(2))                                    !DE
      ckgnmc=ckgnmc/onmc(y(2))/fnmc(y(2))                                              !DE
      ckgnmc=ckgnmc+.5d0*fnmcprime(y(2))/fnmc(y(2))                                    !DE
      ckgnmc=ckgnmc+.5d0*onmcprime(y(2))/onmc(y(2))                                    !DE
      dkgnmc=-grhomatter/2.d0/fnmc(y(2))                                               !DE
      dkgnmc=dkgnmc+1.5d0*gpresmatter/fnmc(y(2))                                       !DE
      dkgnmc=dkgnmc-2.d0*y(1)**2.d0*potential(y(2))/fnmc(y(2))                         !DE
      dkgnmc=dkgnmc*fnmcprime(y(2))/onmc(y(2))                                         !DE
      dkgnmc=dkgnmc+y(1)**2.d0*potentialprime(y(2))/onmc(y(2))                         !DE
      phifdotdot=-bkgnmc*y(3)-ckgnmc*y(3)**2                                           !DE
      phifdotdot=(phifdotdot-dkgnmc)/akgnmc                                            !DE
 	     else                                                                      !DE
      phifdotdot=-2.d0*adotoa*y(3)-1.d0/2.d0/onmc(y(2))*(
     &  onmcprime(y(2))*y(3)**2+2.d0*y(1)*y(1)*potentialprime(y(2)))                   !DE
	     end if                           !DE end if on inmc for Klein Gordon equation
	     if(inmc.ne.0) then  !DE grho, gpres, rhophif, pphif calculation in genelarized/ordinary General Relativity
      grho=grhomatter+onmc(y(2))/2.d0*y(3)**2                                          !DE
      grho=grho+y(1)**2*potential(y(2))-
     &  3.d0*adotoa*fnmcprime(y(2))*y(3)+
     &  grhom*omegav*
     &  y(1)**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))*
     &  y(1)*y(1)*fnmc(y(2))                      !DE
      grho=grho/fnmc(y(2))                                                             !DE
      gpres=gpresmatter+onmc(y(2))/2.d0*y(3)**2                                        !DE
      gpres=gpres-y(1)**2*potential(y(2))                                              !DE
      gpres=gpres+fnmcsecond(y(2))*y(3)**2                                             !DE
      gpres=gpres+fnmcprime(y(2))*phifdotdot                                           !DE
      gpres=gpres+adotoa*fnmcprime(y(2))*y(3)+
     *  (wv+(wbeg-wv)*(1.d0-a))*
     &  grhom*omegav*
     &  y(1)**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))*
     &  y(1)*y(1)*fnmc(y(2))                      !DE
      gpres=gpres/fnmc(y(2))                                                           !DE
cDE   H derivative, featuring calculus only in scalar-tensor cosmology
      adotoadot=(onmc(y(2))+fnmcsecond(y(2)))*y(3)**2                                  !DE
      adotoadot=adotoadot+fnmcprime(y(2))*phifdotdot                                   !DE
      adotoadot=adotoadot-2.d0*adotoa*fnmcprime(y(2))*y(3)                             !DE
      adotoadot=-.5d0*adotoadot/fnmc(y(2))                                             !DE
      adotoadot=adotoadot-.5d0*(grhomatter+gpresmatter)/fnmc(y(2))                     !DE
      adotoadot=adotoadot+adotoa**2                                                    !DE
cDE   Ricci scalar, featuring calculus only in scalar-tensor cosmology
      ricci=(-grhomatter+3.d0*gpresmatter)/y(1)**2+
     &  onmc(y(2))*y(3)**2/y(1)**2                                                     !DE
      ricci=ricci-4.d0*potential(y(2))+
     &  3.d0*(fnmcsecond(y(2))*y(3)**2+ 
     &  fnmcprime(y(2))*phifdotdot)/y(1)**2                                            !DE
      ricci=-(ricci+6.d0*adotoa*fnmcprime(y(2))*y(3)/y(1)**2)/
     &  fnmc(y(2))                                                                     !DE
cDE   conserved rhophi, pphi
      rhophif=1.d0/2.d0*onmc(y(2))*(y(3)/y(1))**2                                      !DE kinetic
      rhophif=rhophif+potential(y(2))                                                  !DE potential
      rhophif=rhophif-
     &  3.d0*(adotoa/y(1))*fnmcprime(y(2))*y(3)/y(1)                                   !DE NMC
      rhophif=rhophif+(-3.d0*(adotoa/y(1))**2)*delta_fnmc(y(2))   		       !DE gravitational
      pphif=1.d0/2.d0*onmc(y(2))*(y(3)/y(1))**2                                        !DE kinetic
      pphif=pphif-potential(y(2))                                                      !DE potential
      pphif=pphif+fnmcsecond(y(2))*(y(3)/y(1))**2+
     &  fnmcprime(y(2))*(phifdotdot/y(1))/y(1)+fnmcprime(y(2))*
     &  (adotoa/y(1))*(y(3)/y(1))			                               !DE NMC
      pphif=pphif+2.d0*(adotoadot/y(1)/y(1)+1.d0/2.d0*
     &  (adotoa/y(1))**2)*delta_fnmc(y(2)) 	  	                               !DE gravitational
		else                                                                   !DE
      grho=grhom*(omegab+omegac)/y(1)+
     &  (grhog+grhor*(annur+annunr*rhonu))/y(1)**2                                     !DE
      grhomattermatter=grhom*(omegab+omegac)/y(1)                                      !DE
      grhomatterradiation=
     &  (grhog+grhor*(annur+annunr*rhonu))/y(1)**2                                     !DE
      gpres=((grhog+grhor*annur)/3.0d0+grhor*annunr*pnu)/y(1)**2                       !DE
      rhophif=1.d0/2.d0*onmc(y(2))*(y(3)/y(1))**2                                      !DE kinetic
      rhophif=rhophif+potential(y(2))                                                  !DE potential
      pphif=1.d0/2.d0*onmc(y(2))*(y(3)/y(1))**2                                        !DE kinetic
      pphif=pphif-potential(y(2))                                                      !DE potential
		end if               !DE end if on grho, gpres, rhophif, pphif in generalized/ordinary General Relativity
      eos=gpres/grho                                                                   !DE
      eosphifguess=pphif/rhophif           !DE bbt: tentative equation of state assignment
cDE   time in Gyrs = (1.d0/306.6d0)*y(4) and redshift
      tgyrs=y(4)/306.6d0                                                               !DE
      red=1.d0/y(1)                                                                    !DE
cDE   writes energy densities
      rhophifmc=1.d0/2.d0*onmc(y(2))*(y(3)/y(1))**2+
     &  potential(y(2))	                                                               !DE
	      if(inmc.ne.0)then                                                        !DE not conserved rhophif calculated
      rhophifnmc=-3.d0*(adotoa/y(1))*fnmcprime(y(2))*(y(3)/y(1))                       !DE
      rhophifnotcons=rhophifmc+rhophifnmc				               !DE
	      else								       !DE
      rhophifnotcons=rhophifmc					                       !DE
	      end if								       !DE
      pphifmc=1.d0/2.d0*onmc(y(2))*(y(3)/y(1))**2-potential(y(2))	               !DE
	      if(inmc.ne.0)then                                                        !DE not conserved pphif calculated
      pphifnmc=fnmcsecond(y(2))*(y(3)/y(1))**2+
     &  fnmcprime(y(2))*(phifdotdot/y(1))/y(1)+
     &  fnmcprime(y(2))*(adotoa/y(1))*(y(3)/y(1))				       !DE
      pphifnotcons=pphifmc+pphifnmc					               !DE
	      else								       !DE
      pphifnotcons=pphifmc						               !DE
	      end if								       !DE
	      if(iwri.eq.0)then 		                                       !DE stops writing if not necessary
      write(1,'(10E14.4)')real(red),3.e3*100.*real(adotoa/y(1)),
     &  real(grhomattermatter/y(1)**2),
     &  real(grhomatterradiation/y(1)**2),real(rhophifmc),
     &  real(rhophifnotcons),real(rhophif),real(pphifmc/rhophifmc),
     &  real(pphifnotcons/rhophifnotcons),real(eosphifguess)		               !DE
	      end if                                                                   !DE 
      age=xout                                                 !DE bbt: conformal time assignment
      phife=y(2)                                               !DE bbt: tentative final field assignment 
      phifdote=y(3)                                            !DE bbt: tentative final field derivative assignment 
cDE   bbt: bisection over scale factor 
      adiff=y(1)-aend                                          !DE bbt: check over aend with 1.d-7 precision
	      if(abs(adiff).lt.1.d-7)then                      !DE
      close(unit=1)                                            !DE
      goto 84                                                  !DE bbt: check on a passed, exit
	      end if                                           !DE
      signadiff=adiff/abs(adiff)                               !DE 
	      if(signadiff.ne.signadiffold)then                !DE bbt: check sign of scale factor increment
      iwri=1                                                   !DE stops writing
      steptau=-steptau/2.d0                                    !DE bbt: reverse scale factor increment and reduces step
      signadiffold=signadiff                                   !DE bbt: reset scale factor increment sign default
	      else                                             !DE
	      end if                                           !DE
      xin=xout                                                 !DE bbt: 
      go to 83                                                 !DE bbt: back for another trajectory
84    adotoaeff=adotoa                                         !DE
	      if(inmc.ne.0) then                               !DE
      omegamatter=(grhom*(omegab+omegac)/y(1)+
     & (grhog+grhor*(annur+annunr*rhonu))/y(1)**2+
     &  grhom*omegav*
     &  y(1)**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))*
     &  y(1)*y(1))/8.d0/pi/fnmc(phife)/adotoaeff**2/3.d0       !DE
      omegaphiftest=(1.d0/2.d0*onmc(phife)*phifdote**2+
     &  potential(phife)*y(1)*y(1))/
     &  3.d0/fnmc(phife)/adotoaeff**2-
     &  fnmcprime(y(2))*y(3)/fnmc(y(2))/adotoaeff              !DE bbt: tentative Omega_DE assignment
              else                                             !DE
      omegamatter=(grhom*(omegab+omegac)/y(1)+
     & (grhog+grhor*(annur+annunr*rhonu))/y(1)**2+
     &  grhom*omegav*
     &  y(1)**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))*
     &  y(1)*y(1))/adotoaeff**2/3.d0                           !DE
      omegaphiftest=8.d0*pi*(1.d0/2.d0*onmc(phife)*phifdote**2+
     &  potential(phife)*y(1)*y(1))/3.d0/adotoaeff**2          !DE bbt: tentative Omega_DE assignment
              end if                 !DE end if on omegamatter and scalar field in generalized/ordinary General Relativity


      eosphiftest=eosphifguess                                 !DE bbt: tentative equation of state assignment
		if((ipot.eq.1).or.(ipot.eq.2))then             !DE bbt: check on omega_DE at present, precision 1.e-3, for inverse power law and SUGRA potentials
			if(dabs(omegaphiftest-omegaphif)/omegaphif.gt.1.d-3)then   !DE
				if(omegaphiftest.gt.omegaphif)then	           !DE
		sign=1.d0				                           !DE bbt: positive sign forcing
		amplipot=amplipot-damplipot	                                   !DE bbt: potential amplitude decreaded
				else					           !DE
		sign=-1.d0				                           !DE bbt: negative sign forcing
		amplipot=amplipot+damplipot	                                   !DE bbt: potential amplitude increased
				end if					           !DE
		amplipot=max(amplipot,1.d-5)	                                   !DE bbt: check for too small amplipot
				if(sign.ne.signold)then		                   !DE bbt: increment reduction on reversal 
      signold=sign				                                   !DE
      damplipot=damplipot/2.d0	                                                   !DE
				end if					           !DE
      phif0=phife				                 !DE bbt: phif0 forcing to speed up convergence
				if(inmc.eq.1)then 	                !DE
      cnmc=(sgnjbd/dsqrt(32.d0*pi*omgjbd*phif0**2)+cnmc)/2.d0           !DE bbt: cnmc forcing to speed up in non-minimally coupled cosmologies
				end if                                  !DE
      go to 369	  	 	 	                                !DE bbt: back for another trajectory
			end if                                          !DE bbt: check on Omega_DE passed, passing through
      damplipot=1.d-1				       		        !DE bbt: amplipot increment reset
!DEtest		
		print*,eosphiftest,wphif,alphapot
			if((dabs((eosphiftest-wphif)/wphif).gt.1.d-3))then	   !DE bbt: check on equation of state, valid only if true cosmological constant is zero
				if(eosphiftest.gt.wphif)then		!DE 
		signeos=1.d0				                !DE bbt: positive sign forcing
		alphapot=alphapot+dalphapot       	                !DE bbt: potential exponent increased
				else					!DE
		signeos=-1.d0				                !DE bbt: negative sign forcing
		alphapot=alphapot-dalphapot	                        !DE bbt: potential exponent increased
				end if					!DE
				if(signeos.ne.signoldeos)then		!DE bbt: increment reduction on reversal 
      signoldeos=signeos                                                !DE
      dalphapot=dalphapot/2.d0                                          !DE
				end if					!DE
      go to 369		      	 	                                !DE bbt: back for another trajectory 
			end if                                          !DE bbt: check on equation of state passed, passing through
		end if                                                  !DE end if on ipot value
cDE   check on field value today, no need to check for inverse power law since the value of phi was forced during bisection
		if((ipot.eq.1).or.(ipot.eq.2))then                      !DE bbt: trajectory found, printing and returning
cDE   field
      phifb=phiftest                                                    !DE
      phifdotb=phifdottest                                              !DE
      print*,'|phi_found-phi_0|/phif_0:',abs(phife-phif0)/phif0         !DE
      print*,'fieldini: phifbeg=',phifb                                 !DE
      print*,'fieldini: phifdotbeg=',phifdotb                           !DE
      print*,'fieldini: phifend=',phife                                 !DE
      print*,'fieldini: phifdotend=',phifdote                           !DE
		      if((ipot.eq.1).or.(ipot.eq.2))then                !DE
      print*,'fieldini: potential amplitude=',amplipot                  !DE
      print*,'fieldini: potential exponent=',alphapot                   !DE
    		      end if                                            !DE
cDE   nmc
		      if(inmc.ne.0) then                                !DE
      print*,'fieldini: omgjbd=',1.d0/8.d0/pi/fnmcprime(phife)**2       !DE
      print*,'fieldini: G_t/G (1/yr)=',
     &  306.6d-9*(-fnmcprime(phife)*phifdote/y(1)/fnmc(phife)+
     &  (2.d0*fnmcprime(phife)*phifdote/y(1)+
     &  8.d0*fnmcsecond(phife)*phifdote/y(1))/
     &  (2.d0*fnmc(phife)+4.d0*fnmcprime(phife)**2.)-
     &  (2.d0*fnmcprime(phife)*phifdote/y(1)+
     &  6.d0*fnmcsecond(phife)*phifdote/y(1))/
     &  (2.d0*fnmc(phife)+3.d0*fnmcprime(phife)**2.))                                       !DE
                      end if                                                                !DE
cDE  cosmological parameters
      print*,'fieldini: omegamatter=',omegamatter                                           !DE
      print*,'fieldini: omegaphi=',omegaphiftest                                            !DE
      print*,'fieldini: eosphi=',eosphiftest                                                !DE
      agegyr=(1.d0/306.6d0)*y(4)                     !DE conversion of c from cm/sec to Mpc/Gyr
      print*,'fieldini: tau0=',age                                                          !DE
      print*,'fieldini: Universe age (Gyr)=',agegyr                                         !DE
      print*,'fieldini: h=',3.e3*adotoaeff                                                  !DE
      print*,'fieldini: a=',y(1)                                                            !DE
      return                                                                                !DE
	      else if(phife.gt.phif0)then                                                   !DE
      phifdown=phiftest                                                                     !DE lower limit reset 
      goto 369                                                                              !DE back for another trajectory
	      else if(phife.lt.phif0)then                                                   !DE 
      phifup=phiftest                                                                       !DE upper limit reset
      goto 369                                                                              !DE back for another trajectory
		end if                                                                      !DE
      end                                                                                   !DE

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cDE   this subroutines integrates Einstein and Klein-Gordon equation, it is used as a check of fieldini
      subroutine ekg(aend,phif,phifdot,abeg,taubeg,tauend)                                  !DE
      implicit double precision (a-h, o-z)                                                  !DE
      parameter (neqn=4)                                                                    !DE
cDE   common lingerinc now contains: 
cDE   effective dark energy present and asimptotic equation of state wv, wvbeg, 
cDE   scalar field dark energy density parameter and equation of state today, omegaphif, wphif
      common /lingerinc/ omegab,omegac,omegav,wv,wvbeg,omegan
     &  ,omegak,h0,tcmb,yhe,annur,annunr,omegaphif,wphif                                    !DE
cDE   common potpar and ggrpar with scalar field dark energy potential parameters
      common /potpar/ alphapot,amplipot,phif0,rkinpot,ipot                                  !DE
      common /ggrpar/ betanmc,cnmc,omgjbd,sgnjbd,inmc                                       !DE
      common /genparm/ grhom,grhog,grhor,adotrad,taurst,dtaurec                             !DE
      common /phifval/ phifbeg,phifdotbeg,phifend,phifdotend                                !DE
      dimension y(4), yprime(4),work(neqn*6+3), iwork(5)                                    !DE
c     y(1)=a,y(2)=phif,y(3)=dphifdtau,y(4)=t ordinary time                                  !DE
      external potential,potentialprime,potentialsecond                                     !DE
      external fnmc,delta_fnmc,fnmcprime,fnmcsecond,fnmcthird                               !DE
      external onmc,onmcprime,onmcsecond                                                    !DE
      external ekgderivsbnmc                                                                !DE
      pi=dacos(-1.d0)                                                                       !DE
c     initial values
      y(1)=abeg                                                                             !DE
      y(2)=phifbeg                                                                          !DE
      y(3)=phifdotbeg                                                                       !DE
      y(4)=0.d0                                                                             !DE
      iflag=1                                                                               !DE
      xin=taubeg                                                                            !DE
      xout=xin                                                                              !DE
cDE   now calling rkf45: it needs routine derivatives name, number of differential equations, y vector, 
cDE   initial and final times; this is the first call in which derivatives are defined and no integration is done 
cDE   a few rows below it is called to integrate forward in time
      call rkf45(ekgderivsbnmc,neqn,y,xin,xout,1.d-10,1.d-10,
     &  iflag,work,iwork)                                                                   !DE
!DEtest
!	print*,y(1),y(2),y(3),y(4),'     1'
      if(iflag.ne.2) print*,'Problem in rkf45, 
     &  first call in ekg, iflag:',iflag                                                    !DE
      xout=tauend                                                                           !DE
      iflag=1                                                                               !DE
      call rkf45(ekgderivsbnmc,neqn,y,xin,xout,1.d-10,1.d-10,
     &  iflag,work,iwork)                                                                   !DE
      if(iflag.ne.2) print*,'Problem in rkf45, 
     &  second call in ekg, iflag:',iflag                                                   !DE
!DEtest
!	print*,y(1),y(2),y(3),y(4),'     1'
      aend=y(1)                                                                             !DE
      phif=y(2)                                                                             !DE
      phifdot=y(3)                                                                          !DE
      if (dabs(aend-1.d0).le.1.d-3) then                  !DE prints for comparison to fieldini
      print*,'ekg: a=',aend                                                                 !DE
      print*,'ekg: phifend=',phif                                                           !DE
      print*,'ekg: phifdotend=',phifdot                                                     !DE
      end if                                                                                !DE
      return                                                                                !DE
      end                                                                                   !DE

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cDE   this subroutines contains derivatives of variables and it's used for scalar field dark 
cDE   energy models, in ordinary as well as scalar-tensor cosmology
      subroutine ekgderivsbnmc(x,y,yprime)                                                  !DE
      implicit double precision (a-h, o-z)                                                  !DE
cDE   common lingerinc now contains: 
cDE   effective dark energy present and asimptotic equation of state wv, wvbeg, 
cDE   scalar field dark energy density parameter and equation of state today, omegaphif, wphif
      common /lingerinc/ omegab,omegac,omegav,wv,wvbeg,omegan
     &  ,omegak,h0,tcmb,yhe,annur,annunr,omegaphif,wphif            !DE
cDE   common potpar and ggrpar with scalar field dark energy potential parameters
      common /potpar/ alphapot,amplipot,phif0,rkinpot,ipot          !DE
      common /ggrpar/ betanmc,cnmc,omgjbd,signjbd,inmc              !DE
      common /genparm/ grhom,grhog,grhor,adotrad,taurst,dtaurec     !DE
      parameter(neqn=4)                                             !DE
      dimension y(4), yprime(4)                                     !DE
cDE   y(1)=a,y(2)=phi,y(3)=phifdot,y(4)= t (not conformal time)
      external potential,potentialprime,potentialsecond             !DE
      external fnmc,delta_fnmc,fnmcprime,fnmcsecond,fnmcthird       !DE
      external onmc,onmcprime,onmcsecond                            !DE
      pi=dacos(-1.d0)                                               !DE
      a=y(1)                                                        !DE
      a2=a*a                                                        !DE
cDE   Hubble expansion rate
      if(a.lt.1.0d-9) then                                          !DE
      rhonu=1.0d0                                                   !DE
      pnu=1.0d0/3.0d0                                               !DE
      else                                                          !DE
      call nu1(a,rhonu,pnu)                                         !DE
      end if                                                        !DE
      if(inmc.ne.0)then                                             !DE
      abgnmc=1.d0                                                   !DE
      bbgnmc=fnmcprime(y(2))*y(3)/fnmc(y(2))                        !DE
      cbgnmc=(grhom*(omegab+omegac)/a+
     &  (grhog+grhor*(annur+annunr*rhonu))/a2)/
     &  8.d0/pi+grhom*omegav*
     &  a**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))*
     &  a2*fnmc(y(2))+
     &	potential(y(2))*a2+onmc(y(2))/2.d0*y(3)**2                  !DE
      cbgnmc=-cbgnmc/(fnmc(y(2))*3.d0)                              !DE
      discriminante=bbgnmc**2-4.d0*abgnmc*cbgnmc                    !DE
      if(discriminante.lt.0.d0) print*,'problems with the generalized 
     &  Einstein equation in ekgderivsbnmc'                         !DE
      adotoa=(-bbgnmc+dsqrt(discriminante))/(2.d0*abgnmc)           !DE
      else                                                          !DE
      adotoa=dsqrt((grhom*(omegac+omegab)/a+(grhog+grhor*
     &  (annur+annunr*rhonu))/a2+
     &  grhom*omegav*
     &  a**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))*
     &  a2+8.d0*pi*(onmc(y(2))/2.d0*y(3)**2+potential(y(2))*a2))
     &  /3.0d0)                                                     !DE
      end if                                                        !DE end if on inmc
      dadtau=adotoa*a                                               !DE
      yprime(1)=dadtau                                              !DE
      yprime(2)=y(3)                                                !DE
cDE   Klein Gordon equation
      if(inmc.ne.0)then                                             !DE
      grhomatter=(grhom*(omegab+omegac)/a+
     &  (grhog+grhor*(annur+annunr*rhonu))/a2)/8.d0/pi              !DE
      gpresmatter=((grhog+grhor*annur)/3.0d0+
     &  grhor*annunr*pnu)/a2/8.d0/pi                                !DE
      akgnmc=1.5d0*fnmcprime(y(2))**2                               !DE
      akgnmc=1.d0+akgnmc/fnmc(y(2))/onmc(y(2))                      !DE
      bkgnmc=1.5d0*fnmcprime(y(2))**2                               !DE
      bkgnmc=2.d0*adotoa*(1.d0+bkgnmc/fnmc(y(2))/onmc(y(2)))        !DE
      ckgnmc=1.5d0*fnmcprime(y(2))*fnmcsecond(y(2))                 !DE
      ckgnmc=ckgnmc/onmc(y(2))/fnmc(y(2))                           !DE
      ckgnmc=ckgnmc+.5d0*fnmcprime(y(2))/fnmc(y(2))                 !DE
      ckgnmc=ckgnmc+onmcprime(y(2))/(2.d0*onmc(y(2)))               !DE
      dkgnmc=-grhomatter/2.d0/fnmc(y(2))                            !DE
      dkgnmc=dkgnmc+1.5d0*gpresmatter/fnmc(y(2))                    !DE
      dkgnmc=dkgnmc-2.d0*a2*potential(y(2))/fnmc(y(2))              !DE
      dkgnmc=dkgnmc*fnmcprime(y(2))/onmc(y(2))                      !DE
      dkgnmc=dkgnmc+a2*potentialprime(y(2))/onmc(y(2))              !DE
      yprime(3)=-bkgnmc*y(3)-ckgnmc*y(3)**2                         !DE
      yprime(3)=(yprime(3)-dkgnmc)/akgnmc                           !DE
      else                                                          !DE
      yprime(3)=-2.d0*adotoa*y(3)-1.d0/2.d0/onmc(y(2))*(
     &  onmcprime(y(2))*a2+2.d0*a2*potentialprime(y(2)))       !DE
      end if                                                        !DE
      yprime(4)=a                                                   !DE dt/dtau=a
!DEtest
!	print*,yprime(1),yprime(2),yprime(3),yprime(4),'     0'
!	print*,-2.d0*adotoa*y(3),-1.d0/2.d0/onmc(y(2))*( 
!     &  onmcprime(y(2))*y(3)**2+2.d0*a2*potentialprime(y(2))),'     00'
      return                                                        !DE
      end                                                           !DE

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cDE     subroutine outtransf_DE makes outputs for perturbations in 
cDE     scalar field dark energy cosmologies
	subroutine outtransf_DE(n,y,yprime,curv,ik,itf)                           !DE

	implicit double precision(a-h,o-z)                                        !DE

        dimension y(n)                                                            !DE
        dimension yprime(n)						          !DE
	parameter (nnmax=11)                                                      !DE

	common /cosmoparm/ beta,beta2,amnu,lmaxg,lmaxnr,
     &                              lmaxnu,nqmax,iq0,iq1,iq2                      !DE
        common /genparm/ grhom,grhog,grhor,adotrad,taurst,dtaurec                 !DE

cDE     lingerinc contains effective dark energy present and asimptotic equation of state wv, wvbeg, 
cDE     scalar field dark energy density parameter and equation of state today, omegaphif, wphif
	common /lingerinc/ omegab,omegac,omegav,wv,wvbeg,omegan
     &  ,omegak,h0,tcmb,yhe,annur,annunr,omegaphif,wphif                          !DE
cDE     common potpar and ggrpar with scalar field dark energy potential parameters
        common /potpar/ alphapot,amplipot,phif0,rkinpot,ipot                      !DE
        common /ggrpar/ betanmc,cnmc,omgjbd,sgnjbd,inmc                           !DE

        external potential,potentialprime,potentialsecond                         !DE
        external fnmc,delta_fnmc,fnmcprime,fnmcsecond,fnmcthird 		  !DE
        external onmc,onmcprime,onmcsecond 				          !DE

	pi=dacos(-1.d0)							 !DE greek pi

	tfc=y(4)/beta2                                                            !DE
	tfb=y(6)/beta2                                                            !DE
	tfg=y(8)/beta2                                                            !DE
	tfn=y(10+2*lmaxg)/beta2                                                   !DE

cDE     calculate transfer function in Newtonian gauge for scalar field if present

	ak=beta							                  !DE
	ak2=beta2						                  !DE
	a=y(1)							                  !DE
	a2=a*a							                  !DE
	adotoa=yprime(1)/y(1)				 	                  !DE
	ahdot=y(2)						                  !DE
	phif=y(n-3)					 	                  !DE
	phifdot=y(n-2)						                  !DE
	phifdotdot=yprime(n-2)					                  !DE
	deltaphif=y(n-1)				 	                  !DE
	deltaphifdot=y(n)					                  !DE
	deltaphifdotdot=yprime(n)				                  !DE
	eta=y(3)						                  !DE
	etadot=yprime(3)					                  !DE
	hdot=y(2)/a						                  !DE
	ahdot=y(2)						                  !DE
	deltab=y(6)						                  !DE
	deltac=y(4)						                  !DE
	deltag=y(8)						                  !DE
	deltar=y(10+2*lmaxg)					                  !DE
	if(a.lt.1.0d-9)then 					                  !DE
        rhonu=1.0d0						                  !DE
        pnu=1.d0/3.d0 						                  !DE
	drhonu=0.0d0						                  !DE
	fnu=0.0d0						                  !DE
	dpnu=0.0d0						                  !DE
	shearnu=0.0d0						                  !DE
 	else 							                  !DE
        call nu1(a,rhonu,pnu) 					                  !DE
	call nu2(a,drhonu,fnu,dpnu,shearnu,y(iq0),y(iq1),y(iq2))                  !DE
	end if 							                  !DE
        if (amnu.eq.0.0) then					                  !DE
        rhonudot=0.0d0						                  !DE
        shearnudot=0.0d0					                  !DE
        else                                                                      !DE
        call nuder(a,adotoa,rhonu,rhonudot,
     &  shearnudot,y(iq2),yprime(iq2))	                                          !DE
        end if							                  !DE
	shearg=y(10)/2.0d0					                  !DE
	sheargdot=yprime(10)/2.d0				                  !DE
	shearr=y(12+2*lmaxg)/2.0d0				                  !DE
	shearrdot=yprime(12+2*lmaxg)/2.0d0			                  !DE
	if(inmc.eq.0)then					                  !DE
	rhophif=1.d0/2.d0*onmc(phif)*phifdot/a*phifdot/a+
     &  potential(phif)	                                                          !DE
        pphif=1.d0/2.d0*onmc(phif)*phifdot/a*phifdot/a-
     &  potential(phif)                                                           !DE
	rhophifdot=onmc(phif)*phifdot/a*
     &  (phifdotdot/a-adotoa*phifdot/a)+
     &  1.d0/2.d0*onmcprime(phif)*phifdot*phifdot/a*phifdot/a+
     &  potentialprime(phif)*phifdot				                  !DE
        pphifdot=onmc(phif)*phifdot/a*
     &  (phifdotdot/a-adotoa*phifdot/a)+
     &  1.d0/2.d0*onmcprime(phif)*phifdot*
     &  phifdot/a*phifdot/a-potentialprime(phif)*phifdot                          !DE
cDE     scalar field sound velocity:
	cs2phif=pphifdot/rhophifdot				                  !DE
cDE     scalar field equation of state:
	wphif=pphif/rhophif					                  !DE
	deltarhophif=onmc(phif)*(phifdot/a)*
     &  (deltaphifdot/a)+
     &  1.d0/2.d0*onmcprime(phif)*(phifdot/a)**2*deltaphif	                  !DE	kinetic 
	deltarhophif=deltarhophif+potentialprime(phif)*deltaphif                  !DE   potential
        deltapphif=onmc(phif)*(phifdot/a)*
     &  (deltaphifdot/a)+
     &  1.d0/2.d0*onmcprime(phif)*(phifdot/a)**2*deltaphif                        !DE   kinetic
        deltapphif=deltapphif-potentialprime(phif)*deltaphif	                  !DE   potential
cDE     hvphif: 
        hvphif=ak/a*onmc(phif)*phifdot/a*deltaphif                                !DE
cDE     calculating ceff2_phi
        ceff2phif=(deltapphif+3.d0*adotoa*cs2phif*hvphif/ak)/
     &  (deltarhophif+3.d0*adotoa*hvphif/ak)			                  !DE
	else							                  !DE
cDE     calculating 8piG a^2 rho total, 8piG a^2 p total 
cDE     and their derivatives according to the formalism developed by J.C. Hwang, Phys.Rev.D 53, 762 (1996)
	grhomatter=(grhom*(omegab+omegac)/a+(grhog+grhor*
     &  (annur+annunr*rhonu))/a2+
     &  grhom*omegav*
     &  a**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))*
     &  a2)/8.d0/pi 	                                                          !DE	
	gpresmatter=(((grhog+grhor*annur)/3.0d0+
     &  grhor*annunr*pnu)/a2+
     &  (wv+(wvbeg-wv)*(1.d0-a))*
     &  grhom*omegav*
     &  a**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))*
     &  a2)/8.d0/pi 	                                                          !DE
cDE     grho and gpres in Extended Quintessence
	grho=grhomatter+onmc(phif)/2.d0*phifdot**2+a2*potential(phif)             !DE
	grho=(grho-3.d0*adotoa*fnmcprime(phif)*phifdot)/fnmc(phif) 	          !DE
	gpres=gpresmatter+onmc(phif)/2.d0*phifdot**2-
     &  a2*potential(phif) 	                                                  !DE
	gpres=gpres+fnmcsecond(phif)*phifdot**2+
     &  fnmcprime(phif)*phifdotdot+
     &  adotoa*fnmcprime(phif)*phifdot			                          !DE
	gpres=gpres/fnmc(phif) 						          !DE
cDE     adotoadot:
	adotoadot=(onmc(phif)+fnmcsecond(phif))*phifdot**2+
     &  fnmcprime(phif)*phifdotdot-
     &  2.d0*adotoa*fnmcprime(phif)*phifdot 		                          !DE
	adotoadot=-.5d0*adotoadot/fnmc(phif) 				          !DE
	adotoadot=adotoadot-
     &  0.5d0*(grhomatter+gpresmatter)/fnmc(phif)+adotoa**2 	                  !DE
cDE     Ricci: 
	ricci=6.d0*(adotoadot+adotoa**2)/a2				          !DE
cDE     conserved rho and phi for scalar field:
        rhophif=1.d0/2.d0*onmc(phif)*(phifdot/a)**2                               !DE  kinetic
        rhophif=rhophif+potential(phif)                                           !DE  potential
        rhophif=rhophif-
     &  3.d0*(adotoa/a)*fnmcprime(phif)*(phifdot/a)                               !DE  NMC
        rhophif=rhophif-3.d0*(adotoa/a)**2*delta_fnmc(phif) 		  	  !DE  gravitational
cDE     here is an equivalent way of calculating conserved rhophif
cDE	rhophif=-grhomatter/a2+grho/a2/8.d0/pi		                          !DE
        pphif=1.d0/2.d0*onmc(phif)*(phifdot/a)**2                                 !DE  kinetic
        pphif=pphif-potential(phif)                                               !DE  potential
        pphif=pphif+fnmcsecond(phif)*(phifdot/a)**2+
     &  fnmcprime(phif)*(phifdotdot/a)/a+
     &  fnmcprime(phif)*(adotoa/a)*(phifdot/a)                                    !DE  NMC
        pphif=pphif+2.d0*(adotoadot/a/a+1.d0/2.d0*
     &  (adotoa/a)**2)*delta_fnmc(phif) 	  		                  !DE  gravitational
cDE     here is an equivalent way of calculating conserved pphif
cDE	pphif=-gpresmatter/a2+gpres/a2/8.d0/pi		                          !DE
	rhophifdot=-3.d0*adotoa*(rhophif+pphif)                                   !DE
cDE     conserved pphifdot, grhomatterdot, gpresmatterdot needed
cDE     G*dot(a2*rho_(matter and radiation))
	grhomatterdot=((-grhom*(omegab+omegac)/a-2.d0*(grhog+
     &  grhor*(annur+annunr*rhonu))/a2)*adotoa+
     &  grhor*annunr*rhonudot/a2+
     &  grhom*omegav*(-1.d0-3.d0*(wv+(wvbeg-wv)*(a-1.d0)))*
     &  a**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv)))*
     &  a2*adotoa/8.d0/pi 	                                                  !DE
cDE     G*dot(a2*p_(matter and radiation))
	gpresmatterdot=-2.d0*adotoa*((grhog+
     &  grhor*annur)/3.d0+annunr*pnu)/a2-
     &  (wvbeg-wv)*grhom*omegav*a2*
     &  a**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))+
     &  adotoa*(wv+(wvbeg-wv)*(1.d0-a))*
     &  grhom*a2*omegav*(-1.d0-3.d0*(wv+(wvbeg-wv)*(a-1.d0)))*
     &  a**(-3.d0*(1.d0+wvbeg))*dexp(3.d0*(a-1.d0)*(wvbeg-wv))                    !DE
		if(amnu.ne.0.0d0)then                                             !DE
	gpresmatterdot=gpresmatterdot+
     &  grhor*annunr*dpnu/drhonu*rhonudot/a2/8.d0/pi 		                  !DE
		end if							          !DE
cDE     phifdotdotdot needed: 
        phifdotdotdot=-2.d0*adotoadot*phifdot-
     &  2.d0*adotoa*phifdotdot-
     &  2.d0*onmcprime(phif)/onmc(phif)*phifdot*phifdotdot-
     &  2.d0*onmcprime(phif)/onmc(phif)*adotoa*phifdot**2-
     &  onmcsecond(phif)/2.d0/onmc(phif)*phifdot**3+
     &  a*a/2.d0/onmc(phif)*fnmcsecond(phif)*phifdot*ricci-
     &  2.d0*a*a/onmc(phif)*adotoa*potentialprime(phif)-
     &  a*a/onmc(phif)*potentialsecond(phif)*phifdot+
     &  12.d0*fnmcprime(phif)/onmc(phif)*adotoa*adotoadot-
     &  3.d0*fnmcprime(phif)**2*phifdot/onmc(phif)/
     &  fnmc(phif)*adotoadot+3.d0*fnmcprime(phif)**2*phifdot/
     &  onmc(phif)/fnmc(phif)*adotoa**2-
     &  3.d0*fnmcprime(phif)/2.d0/onmc(phif)/fnmc(phif)*
     &  (grhomatterdot+gpresmatterdot)-3.d0*fnmcprime(phif)*
     &  onmcprime(phif)/2.d0/onmc(phif)/fnmc(phif)*phifdot**3-
     &  3.d0*fnmcprime(phif)/fnmc(phif)*phifdot*phifdotdot-
     &  3.d0*fnmcprime(phif)*fnmcthird(phif)/2.d0/
     &  onmc(phif)/fnmc(phif)*phifdot**3-
     &  9.d0/2.d0*fnmcprime(phif)*
     &  fnmcsecond(phif)/fnmc(phif)/onmc(phif)*phifdot*phifdotdot+
     &  3.d0*fnmcprime(phif)**2/fnmc(phif)/
     &  onmc(phif)*adotoadot*phifdot+3.d0*fnmcprime(phif)*
     &  fnmcsecond(phif)/fnmc(phif)/onmc(phif)*adotoa*phifdot**2+
     &  3.d0/2.d0*fnmcprime(phif)**2/
     &  fnmc(phif)/onmc(phif)*adotoa*phifdotdot	                                   !DE
        phifdotdotdot=phifdotdotdot/(1.d0+
     &  3.d0/2.d0*fnmcprime(phif)**2/fnmc(phif)/onmc(phif))		           !DE
cDE     adotoadotdot needed: 
        adotoadotdot=2.d0*adotoa*adotoadot+
     &  fnmcprime(phif)*phifdot/fnmc(phif)*
     &  (adotoa**2-adotoadot)-
     &  1.d0/2.d0/fnmc(phif)*(grhomatterdot+gpresmatterdot+
     &  2.d0*onmc(phif)*phifdot*phifdotdot+
     &  onmcprime(phif)*phifdot**3+fnmcthird(phif)*phifdot**3+
     &  3.d0*fnmcsecond(phif)*phifdot*phifdotdot+
     &  fnmcprime(phif)*phifdotdotdot-
     &  2.d0*adotoadot*fnmcprime(phif)*phifdot-
     &  2.d0*adotoa*fnmcsecond(phif)*phifdot**2-
     &  2.d0*adotoa*fnmcprime(phif)*phifdotdot)				           !DE
cDE     pphifdot: 
        pphifdot=1.d0/2.d0*onmcprime(phif)*phifdot*(phifdot/a)**2+
     &  onmc(phif)*(phifdot/a)*(phifdotdot/a-phifdot/a*adotoa)                     !DE  kinetic         
	pphifdot=pphifdot-potentialprime(phif)*phifdot                             !DE  potential
        pphifdot=pphifdot+fnmcthird(phif)*(phifdot/a)**2*phifdot+
     &  fnmcsecond(phif)*2.d0*(phifdot/a)*
     &  (phifdotdot/a-phifdot*adotoa/a)-
     &  2.d0/a*(adotoa/a)*(phifdotdot*fnmcprime(phif)+
     &  adotoa*phifdot*fnmcprime(phif))+
     &  phifdotdotdot/a*fnmcprime(phif)/a+
     &  phifdotdot/a*fnmcsecond(phif)*(phifdot/a)+
     &  adotoadot/a*phifdot/a*fnmcprime(phif)+
     &  adotoa/a*phifdotdot/a*fnmcprime(phif)+
     &  adotoa/a*phifdot/a*fnmcsecond(phif)*phifdot			           !DE  NMC
	pphifdot=pphifdot-(4.d0*adotoa*(adotoadot/a/a+
     &  1.d0/2.d0*(adotoa/a)**2)-
     &  2.d0*(adotoadotdot/a/a+adotoa/a*adotoadot/a))*
     &  delta_fnmc(phif)+2.d0*(adotoadot/a/a+
     &  1.d0/2.d0*(adotoa/a)**2)*fnmcprime(phif)*phifdot                           !DE  gravitational    

cDE     calculating scalar field sound speed
	cs2phif=pphifdot/rhophifdot					           !DE

cDE     calculating scalar field equation of state
	wphif=pphif/rhophif						           !DE

cDE     calculating 8piG a^2 delta rho(matter) and 8piG a^2 deltap(matter): 
	dgrho=grhom*(omegac*deltac+omegab*deltab)/a+
     &  (grhog*deltag+grhor*(annur*deltar+annunr*drhonu))/a2
	dgrhomatter=dgrho/8.d0/pi                                                  !DE
	dgrho=dgrhomatter+
     &  onmc(phif)*phifdot*deltaphifdot+
     &  0.5d0*(phifdot**2.d0*onmcprime(phif)+
     &  2.d0*a2*potentialprime(phif))*deltaphif		                           !DE  kinetic + potential
	dgrho=(dgrho-3.d0*adotoa*(fnmcsecond(phif)*phifdot*deltaphif+
     &  fnmcprime(phif)*deltaphifdot)-ak2*fnmcprime(phif)*deltaphif-
     &  3.d0*adotoa**2.d0*fnmcprime(phif)*deltaphif-
     &	fnmcprime(phif)*phifdot*ahdot/2.d0/a)/fnmc(phif)                           !DE  NMC
	dgpres=(grhog*deltag+grhor*annur*deltar)/a2/3.0d0+
     &  grhor*annunr*dpnu/a2                                                       !DE
	dgpresmatter=dgpres/8.d0/pi			                           !DE
	dgpres=dgpresmatter+onmc(phif)*phifdot*deltaphifdot+
     &  1.d0/2.d0*onmcprime(phif)*phifdot*phifdot*deltaphif-
     &  a2*potentialprime(phif)*deltaphif				           !DE
	dgpres=(dgpres+fnmcthird(phif)*phifdot*phifdot*deltaphif+
     &  2.d0*fnmcsecond(phif)*phifdot*deltaphifdot+fnmcsecond(phif)*
     &  phifdotdot*deltaphif+fnmcprime(phif)*deltaphifdotdot+
     &  adotoa*fnmcsecond(phif)*phifdot*deltaphif+
     &  adotoa*fnmcprime(phif)*deltaphifdot-
     &  gpres*fnmcprime(phif)*deltaphif+
     &  2.d0/3.d0*ak2*fnmcprime(phif)*deltaphif+
     &  1.d0/3.d0*fnmcprime(phif)*phifdot*ahdot/a)/fnmc(phif)                      !DE 
cDE     conserved deltarho(p):  
        deltarhophif=onmc(phif)*(phifdot/a)* 
     &  (deltaphifdot/a)+
     &  1.d0/2.d0*onmcprime(phif)*(phifdot/a)**2*deltaphif 	                   !DE  kinetic 
        deltarhophif=deltarhophif+potentialprime(phif)*deltaphif 	           !DE  potential 
        deltarhophif=deltarhophif-
     &  3.d0*(adotoa/a)*fnmcprime(phif)*(deltaphifdot/a)- 
     &  3.d0*(adotoa/a)*fnmcsecond(phif)*(phifdot/a)*deltaphif-
     &  (ak/a)**2*fnmcprime(phif)*deltaphif-
     &  3.d0*fnmcprime(phif)*(phifdot/a)*ahdot/a/a/6.d0                            !DE  NMC 
        deltarhophif=deltarhophif+dgrho/a2*(-delta_fnmc(phif))-
     &  3.d0*(adotoa/a)**2*fnmcprime(phif)*deltaphif 			           !DE  gravitational 

cDE     here below an equivalent way to calculate conserved deltarhophif
cDE     deltarhophif=-dgrhomatter/a2+dgrho/a2/8.d0/pi 			           !DE 
        deltapphif=onmc(phif)*phifdot/a*deltaphifdot/a+ 
     &  1.d0/2.d0*onmcprime(phif)*phifdot/a*phifdot/a*deltaphif- 
     &  potentialprime(phif)*deltaphif					           !DE  kin + pot 
        deltapphif=deltapphif+
     &  fnmcthird(phif)*phifdot/a*phifdot/a*deltaphif+ 
     &  fnmcsecond(phif)*phifdotdot/a*deltaphif/a+
     &  2.d0*fnmcsecond(phif)*phifdot/a*deltaphifdot/a+
     &  adotoa/a*fnmcsecond(phif)*phifdot/a*deltaphif+ 
     &  adotoa/a*fnmcprime(phif)*deltaphifdot/a+
     &  fnmcprime(phif)*deltaphifdotdot/a2+ 
     &  2.d0/3.d0*ak2/a2*fnmcprime(phif)*deltaphif+
     &  1.d0/3.d0*ahdot/a/a*fnmcprime(phif)*phifdot/a 			           !DE  NMC
        deltapphif=deltapphif-gpres/a2*fnmcprime(phif)*deltaphif-
     &  dgpres/a2*delta_fnmc(phif) 					           !DE  gravitational

cDE     here below an equivalent way to calculate conserved deltapphif
cDE	deltapphif=-dgpresmatter/a2+dgpres/a2/8.d0/pi		 	           !DE

cDE     calculating h_phi*v_phi: 
	hvphif=ak/a*(onmc(phif)*phifdot/a*deltaphif+
     &  fnmcsecond(phif)*phifdot/a*
     &  deltaphif+fnmcprime(phif)*deltaphifdot/a-
     &  adotoa/a*fnmcprime(phif)*
     &  deltaphif-2.d0*delta_fnmc(phif)*etadot/a)				   !DE

cDE     calculating ceff2_phi
	ceff2phif=(deltapphif+3.d0*adotoa*cs2phif*hvphif/ak)/
     &  (deltarhophif+3.d0*adotoa*hvphif/ak)				           !DE

cDE     calculating cvis2phif from HU APJ506, 485 1998, formula 12
cDE     not conserved dgshear, dgsheardot needed:
cDE     8*pi*G*(rho+P)*sigma*a**2
	dgshear=4.0d0/3.0d0*(grhog*shearg+annur*grhor*shearr)/a2+
     &  annunr*grhor*shearnu/a2				                           !DE
	dgshearmatter=dgshear/8.d0/pi                                              !DE
	dgshear=(dgshearmatter+
     &  2.d0*ak2/3.d0*(fnmcprime(phif)*deltaphif+3.d0*
     &  fnmcprime(phif)*
     &  phifdot/ak2*(etadot+ahdot/a/6.d0)))/fnmc(phif)			           !DE
	dgshearmatterdot=-2.d0*adotoa*dgshearmatter+
     &  (4.0d0/3.0d0*(grhog*sheargdot+annur*grhor*shearrdot)/a2+
     &  annunr*grhor*shearnudot/a2)/8.d0/pi                                        !DE
	dgsheardot=-fnmcprime(phif)*phifdot/fnmc(phif)*dgshear+
     &  (dgshearmatterdot+2.d0*ak2/3.d0*(
     &  fnmcprime(phif)*deltaphifdot+
     &  fnmcsecond(phif)*phifdot*deltaphif+
     &  3.d0*fnmcsecond(phif)*
     &  phifdot**2/ak2*(etadot+ahdot/a/6.d0)+
     &  3.d0*fnmcprime(phif)*phifdot/ak2*(
     &  -1.d0/3.d0*adotoa*(etadot+ahdot/a/6.d0)+
     &  1.d0/3.d0*ak2*eta-1.d0/2.d0*dgshear)))/fnmc(phif)                          !DE
cDE     p*Pi_T(dot) needed: 
	pPiTphif=(ahdot/2.d0/a/a+3.d0*etadot/a)*
     &  fnmcprime(phif)*phifdot/a+
     &  fnmcprime(phif)*deltaphif*(ak/a)**2				           !DE  NMC
	pPiTphif=pPiTphif-3.d0/2.d0*dgshear/a2*delta_fnmc(phif)			   !DE  grav

	ptimesPiTphifdot=-2.d0*adotoa*pPiTphif-
     &  pphifdot*pPiTphif/pphif+
     &  (-adotoa*(ahdot/a+6.d0*etadot)+
     &  ak2*eta-3.d0/2.d0*dgshear)/a*
     &  fnmcprime(phif)*phifdot/a+(ahdot/a/2.d0+3.d0*etadot)*
     &  fnmcsecond(phif)*(phifdot/a)**2+
     &  (ahdot/a/2.d0+3.d0*etadot)*
     &  fnmcprime(phif)*phifdotdot/a/a+
     &  fnmcsecond(phif)*phifdot*deltaphif*(ak/a)**2+
     &  fnmcprime(phif)*deltaphifdot*(ak/a)**2-
     &  3.d0/2.d0*dgshear/a/a*fnmcprime(phif)*phifdot-
     &  delta_fnmc(phif)*3.d0/2.d0*dgsheardot/a/a				           !DE

cDE     cvis2phif: 
	cvis2phif=(ptimesPiTphifdot+3.d0*adotoa*pPiTphif/rhophif)/
     &  4.d0*(ak*hvphif/(rhophif+pphif)+ahdot/a/2.d0+3.d0*etadot)	           !DE

	end if								           !DE

cDE     now writing delta rho/rho for scalar field in synchronous and newtonian gauges
	deltarhooverrhophif_syn=deltarhophif/rhophif				   !DE
cDE	deltarhooverrhophif_New=deltarhooverrhophif_syn+			   !DE
cDE     &	((hdot/2.d0+3.d0*etadot)/ak2)*rhophifdot/rhophif		   !DE

cDE     now writing transfer function for scalar field in Newtonian gauge
	tfphif=deltarhooverrhophif_syn/ak2					   !DE

	if (amnu.ne.0.0d0) then                                                    !DE
           a=y(1)                                                                  !DE
           call nu1(a,rhonu,pnu)                                                   !DE
           call nu2(a,drhonu,fnu,dpnu,shearnu,y(iq0),y(iq1),y(iq2))                !DE
           deltan=drhonu/rhonu                                                     !DE
           tfnm=deltan/beta2                                                       !DE
	endif                                                                      !DE

cDE     output k in units of Mpc/h
	if (amnu.eq.0.0d0) then							   !DE
	write(12+itf,'(10E14.6)')beta/(h0/100.d0),tfc,tfb,tfg,tfn,
     &  tfphif,ceff2phif,wphif,cs2phif,cvis2phif				   !DE
cDE	write(12+itf,'(10E14.6)')beta/(h0/100.d0),tfphif,
cDE     &  ahdot/a,phifdot,deltaphifdot
	else									   !DE
	write(12+itf,'(11E14.6)')beta/(h0/100.d0),tfc,tfb,tfg,tfn,
     &  tfnm,tfphif,ceff2phif,wphif,cs2phif,cvis2phif				   !DE
	end if									   !DE
 	return
 	end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cDE   here below scalar field dark energy external functions 
cDE   potential
      function potential(phif)                                      !DE
      implicit double precision (a-h, o-z)                          !DE
cDE   common potpar with scalar field dark energy potential parameters
      common /potpar/ alphapot,amplipot,phif0,rkinpot,ipot          !DE
      common /genparm/ grhom,grhog,grhor,adotrad,taurst,dtaurec     !DE
      pi=dacos(-1.d0)                                               !DE
      if(ipot.eq.1)then                                             !DE
      potential=amplipot*grhom/8.d0/pi*(phif/phif0)**alphapot       !DE inverse power law potential
      else if(ipot.eq.2)then                                        !DE 
      potential=amplipot*grhom/8.d0/pi*(phif/phif0)**alphapot       !DE
      potential=potential*dexp(4.d0*pi*(phif**2-phif0**2))          !DE SUGRA potential
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE
cDE   potentialprime
      function potentialprime(phif)                                 !DE
      implicit double precision (a-h, o-z)                          !DE
cDE   common potpar with scalar field dark energy potential parameters
      common /potpar/ alphapot,amplipot,phif0,rkinpot,ipot          !DE
      common /genparm/ grhom,grhog,grhor,adotrad,taurst,dtaurec     !DE
      pi=dacos(-1.d0)                                               !DE
      if(ipot.eq.1)then                                             !DE
      potentialprime=amplipot*grhom/8.d0/pi*alphapot/phif0*
     &  (phif/phif0)**(alphapot-1.d0)                               !DE inverse power law potential
      else if(ipot.eq.2)then                                        !DE
      potential=amplipot*grhom/8.d0/pi*(phif/phif0)**alphapot       !DE
      potentialprime=amplipot*grhom/8.d0/pi*alphapot/phif0*
     &  (phif/phif0)**(alphapot-1.d0)                               !DE 
      potentialprime=potentialprime*exp(4.d0*pi*(phif**2-phif0**2))+
     &  potential*8.d0*pi*phif*dexp(4.d0*pi*(phif**2-phif0**2))     !DE SUGRA potential
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE
cDE   potentialsecond
      function potentialsecond(phif)                                !DE
      implicit double precision (a-h, o-z)                          !DE
cDE   common potpar with scalar field dark energy potential parameters
      common /potpar/ alphapot,amplipot,phif0,rkinpot,ipot          !DE
      common /genparm/ grhom,grhog,grhor,adotrad,taurst,dtaurec     !DE
      pi=dacos(-1.d0)                                               !DE
      if(ipot.eq.1)then                                             !DE
      potentialsecond=amplipot*grhom/8.d0/pi*alphapot/phif0*
     &  (alphapot-1.d0)/phif0*(phif/phif0)**(alphapot-2.d0)         !DE inverse power law potential
      else if(ipot.eq.2)then                                        !DE
      potential=amplipot*grhom/8.d0/pi*(phif/phif0)**alphapot       !DE 
      potentialprime=amplipot*grhom/8.d0/pi*alphapot/phif0*
     &  (phif/phif0)**(alphapot-1.d0)                               !DE 
      potentialsecond=potentialsecond*
     &  exp(4.d0*pi*(phif**2-phif0**2))+
     &  16.d0*pi*potentialprime*phif*
     &  dexp(4.d0*pi*(phif**2-phif0**2))+
     &  8.d0*pi*potential*dexp(4.d0*pi*(phif**2-phif0**2))*
     &  (1.d0+8.d0*pi*phif**2)                                      !DE SUGRA potential 
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE
cDE   NMC coupling function fnmc
      function fnmc(phif)                                           !DE
      implicit double precision (a-h, o-z)                          !DE
cDE   common potpar ggrpar with scalar field dark energy potential parameters
      common /potpar/ alphapot,amplipot,phif0,rkinpot,ipot          !DE
      common /ggrpar/ betanmc,cnmc,omgjbd,sgnjbd,inmc               !DE
      common /genparm/ grhom,grhog,grhor,adotrad,taurst,dtaurec     !DE
      external onmc                                                 !DE
      pi=dacos(-1.d0)                                               !DE
      if(inmc.eq.1)then                                             !DE
cDE      fnmc=(1.d0+8.d0*pi*cnmc*(phif**betanmc-phif0**betanmc))       !DE
cDE      fnmc=fnmc/8.d0/pi                                             !DE
cDE   09/01/01:the following lines refine the value at present of 
cDE   fnmc to reproduce the measured Gravitational constant, from 
cDE   3.5 of Esposito-Farese paper astro-ph/0009034
      fnmcprimenow=2.d0*cnmc*phif0                                  !DE
      Afnmcnow=16.d0*pi*onmc(phif0)                                 !DE
      Bfnmcnow=24.d0*pi*fnmcprimenow**2-2.d0*onmc(phif0)            !DE
      Cfnmcnow=-4.d0*fnmcprimenow**2                                !DE
      fnmcnow=(-Bfnmcnow+
     &  dsqrt(Bfnmcnow**2-4.d0*Afnmcnow*Cfnmcnow))/2.d0/Afnmcnow    !DE
      fnmc=fnmcnow+cnmc*(phif**betanmc-phif0**betanmc)              !DE
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE
      function delta_fnmc(phif)                                     !DE
      implicit double precision (a-h, o-z)                          !DE
cDE   common potpar ggrpar with scalar field dark energy potential parameters
      common /potpar/ alphapot,amplipot,phif0,rkinpot,ipot          !DE
      common /ggrpar/ betanmc,cnmc,omgjbd,sgnjbd,inmc               !DE
      common /genparm/ grhom,grhog,grhor,adotrad,taurst,dtaurec     !DE
      external onmc                                                 !DE
      pi=dacos(-1.d0)                                               !DE
      if(inmc.eq.1)then                                             !DE
      delta_fnmc=cnmc*phif**betanmc                                 !DE
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE
cDE   fnmcprime
      function fnmcprime(phif)                                      !DE
      implicit double precision (a-h, o-z)                          !DE
cDE   common ggrpar with scalar field dark energy potential parameters
      common /ggrpar/ betanmc,cnmc,omgjbd,sgnjbd,inmc               !DE
      if(inmc.eq.1)then                                             !DE
      fnmcprime=betanmc*cnmc*phif**(betanmc-1.d0)                   !DE
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE
cDE   fnmcsecond
      function fnmcsecond(phif)                                     !DE
      implicit double precision (a-h, o-z)                          !DE
cDE   common ggrpar with scalar field dark energy potential parameters
      common /ggrpar/ betanmc,cnmc,omgjbd,sgnjbd,inmc               !DE
      if(inmc.eq.1)then                                             !DE
      fnmcsecond=betanmc*(betanmc-1.d0)*cnmc*phif**(betanmc-2.d0)   !DE
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE
cDE   fnmcthird
      function fnmcthird(phif)                                      !DE
      implicit double precision (a-h, o-z)                          !DE
cDE   common ggrpar with scalar field dark energy potential parameters
      common /ggrpar/ betanmc,cnmc,omgjbd,sgnjbd,inmc               !DE
      if(inmc.eq.1)then                                             !DE
      fnmcthird=betanmc*(betanmc-1.d0)*(betanmc-2.d0)*
     &  cnmc*phif**(betanmc-3.d0)                                   !DE
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE
cDE   generalised kinetic coupling onmc
      function onmc(phif)                                           !DE
      implicit double precision (a-h, o-z)                          !DE
      if((inmc.eq.0).or.(inmc.eq.1))then                            !DE
      onmc=1.d0                                                     !DE
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE
cDE   onmcprime
      function onmcprime(phif)                                      !DE
      implicit double precision (a-h, o-z)                          !DE
      if((inmc.eq.0).or.(inmc.eq.1))then                            !DE
      onmcprime=0.d0                                                !DE
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE
cDE   onmcsecond
      function onmcsecond(phif)                                     !DE
      implicit double precision (a-h, o-z)                          !DE
      if((inmc.eq.0).or.(inmc.eq.1))then                            !DE
      onmcsecond=0.d0                                               !DE
      end if                                                        !DE
      return                                                        !DE
      end                                                           !DE

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cDE   here below there are subroutines used for numerical integration 
cDE   in scalar field dark energy cosmologies

C*************************************************************************
C****************************      RKF45     *****************************
C*************************************************************************

        subroutine rkf45(f,neqn,y,t,tout,relerr,abserr,iflag,work,iwork)

        implicit double precision (a-h,o-z)

cDE   lingerinc contains effective dark energy present and asimptotic equation of state wv, wvbeg, 
cDE   scalar field dark energy density parameter and equation of state today, omegaphif, wphif
      common /lingerinc/ omegab,omegac,omegav,wv,wvbeg,omegan
     &  ,omegak,h0,tcmb,yhe,annur,annunr,omegaphif,wphif                    !DE

        common /phifval/ phifbeg,phifdotbeg,phifend,phifdotend !@
        common /genparm/ grhom,grhog,grhor,adotrad,taurst,dtaurec
        dimension iwork(5)
        dimension y(neqn),work(neqn*6+3)

        external f
C ****n.d.C.:F DEVE ESSERE DELLA FORMA F(variabile indip.,var.dip.,derivata) 

        k1m=neqn+1
        k1=k1m+1
        k2=k1+neqn
        k3=k2+neqn
        k4=k3+neqn
        k5=k4+neqn
        k6=k5+neqn

        call rkfs(f,neqn,y,t,tout,relerr,abserr,iflag,work(1),
     &  work(k1m),work(k1),work(k2),work(k3),work(k4),work(k5),
     &  work(k6),work(k6+1),iwork(1),iwork(2),iwork(3),iwork(4),
     &  iwork(5))

        return
        end


C*************************************************************************
C****************************      RKFS     ******************************
C*************************************************************************

        subroutine rkfs(f,neqn,y,t,tout,relerr,abserr,iflag,yp,h,f1,f2,
     &  f3,f4,f5,savre,savae,nfe,kop,init,jflag,kflag)

C*************************************************************************
C*************************************************************************
C    Bisogna dargli come data il numero massimo di steps che puo'        *
C    eseguire nell'andare da t a tout                                    *
C    maxnfe=3000 e' circa 500 steps                                      *
c ( per questo mettiamo 30000000 , affinche' non si fermi dopo soli 3000
c  step, dato che integriamo su intervalli molto grandi!! n.d.C.)
C*************************************************************************
C*************************************************************************
        
        implicit double precision (a-h,o-z)
        logical hfaild,output
        dimension y(neqn),yp(neqn),f1(neqn),f2(neqn),f3(neqn),f4(neqn),
     &  f5(neqn)

        external f

        data remin/1.d-12/
        data maxnfe/30000000/
        if (neqn.lt.1) go to 10
        if ((relerr.lt.0.d0).or.(abserr.lt.0.d0)) go to 10
        mflag=iabs(iflag)
        if ((mflag.eq.0).or.(mflag.gt.8)) go to 10
        if (mflag.ne.1) go to 20
        eps=1.d0
5       eps=eps/2.d0
        epsp1=eps+1.d0
        if (epsp1.gt.1.d0) go to 5
        u26=26.d0*eps
        go to 50
10      iflag=8
        return
20      if ((t.eq.tout).and.(kflag.ne.3)) go to 10
        if (mflag.ne.2) go to 25
        if ((kflag.eq.3).or.(init.eq.0))go to 45
        if (kflag.eq.4) go to 40
        if ((kflag.eq.5).and.(abserr.eq.0.d0)) go to 30
        if ((kflag.eq.6).and.(relerr.le.savre).and.
     1          (abserr.le.savae)) go to 30
        go to 50
25      if (iflag.eq.3) go to 45
        if (iflag.eq.4) go to 40
        if ((iflag.eq.5).and.(abserr.gt.0.d0)) go to 45
30      stop
40      nfe=0
        if (mflag.eq.2) go to 50
45      iflag=jflag
        if (kflag.eq.3) mflag=iabs(iflag)
50      jflag=iflag
        kflag=0
        savre=relerr
        savae=abserr
        rer=2.d0*eps+remin
        if (relerr.ge.rer) go to 55
        relerr=rer
        iflag=3
        kflag=3
        return

55      dt=tout-t
        if (mflag.eq.1) go to 60
        if (init.eq.0) go to 65
        go to 80
60      init=0
        kop=0
        a=t
        call f(a,y,yp)
        nfe=1
        if (t.ne.tout) go to 65
        iflag=2
        return
65      init=1
        h=dabs(dt)
        toln=0.d0
        do 70 k=1,neqn
        tol=relerr*dabs(y(k))+abserr
        if (tol.le.0.d0) go to 70
        toln=tol
        ypk=dabs(yp(k))
        if (ypk*h**5.d0.gt.tol) h=(tol/ypk)**0.2d0
70      continue
        if (toln.le.0.d0) h=0.d0        
        h=dmax1(h,u26*dmax1(dabs(t),dabs(dt)))
        jflag=isign(2,iflag)
80      h=dsign(h,dt)
        if (dabs(h).ge.2.d0*dabs(dt)) kop=kop+1
C METTO 1D35 ANZICHE' 100 PER NON FARLO FERMARE DOPO POCHI STEP, DATO CHE
C NOI INTEGRIAMO SU INTERVALLI MOLTO GRANDI. SI VUOLE ESAGERARE.        
	if (kop.ne.1d35) go to 85
        kop=0
        iflag=7
        return
85      if (dabs(dt).gt.u26*dabs(t)) go to 95
        do 90 k=1,neqn
90        y(k)=y(k)+dt*yp(k)
        a=tout
        call f(a,y,yp)
        nfe=nfe+1
        go to 300
95      output=.false.
        scale=2.d0/relerr
        ae=scale*abserr
100     hfaild=.false.
        hmin=u26*dabs(t)
        dt=tout-t
        if(dabs(dt).ge.2.d0*dabs(h)) go to 200
        if(dabs(dt).gt.dabs(h)) go to 150
        output=.true.
        h=dt
        go to 200
150     h=0.5d0*dt
200     if (nfe.le.maxnfe) go to 220
        iflag=4
        kflag=4
        return
220     call fehl(f,neqn,y,t,h,yp,f1,f2,f3,f4,f5,f1)
        nfe=nfe+5
        eeoet=0.d0
        do 250 k=1,neqn
          et=dabs(y(k))+dabs(f1(k))+ae
          if (et.gt.0.d0) go to 240
          iflag=5
          return
240       ee=dabs((-2090.d0*yp(k)+(21970.d0*f3(k)-15048.d0*f4(k)))+
     1          (22528.d0*f2(k)-27360.d0*f5(k)))
250       eeoet=dmax1(eeoet,ee/et)
        esttol=dabs(h)*eeoet*scale/752400.d0
        if (esttol.le.1.d0) go to 260
        hfaild=.true.
        output=.false.
        s=0.1d0
        if (esttol.lt.59049.d0) s=0.9d0/esttol**0.2d0
        h=s*h
        if (dabs(h).gt.hmin) go to 200
        iflag=6
        kflag=6
        return
260     t=t+h
        do 270 k=1,neqn
270       y(k)=f1(k)
        a=t
        call f(a,y,yp)
        nfe=nfe+1
        s=5.d0
        if (esttol.gt.1.889568d-4) s=0.9d0/esttol**0.2d0
        if (hfaild) s=dmin1(s,1.d0)
        h=dsign(dmax1(s*dabs(h),hmin),h)
        if (output) go to 300
        if (iflag.gt.0.d0) go to 100
        iflag=-2
        return
300     t=tout
        iflag=2
       return
        end


C*************************************************************************
C****************************     FEHL     *******************************
C*************************************************************************

        subroutine fehl(f,neqn,y,t,h,yp,f1,f2,f3,f4,f5,s)

        implicit double precision (a-h,o-z)

        dimension y(neqn),yp(neqn),f1(neqn),f2(neqn),
     1          f3(neqn),f4(neqn),f5(neqn),s(neqn)

        external f

        ch=h/4.d0
        do 221 k=1,neqn
221       f5(k)=y(k)+ch*yp(k)
        call f(t+ch,f5,f1)
        ch=3.d0*h/32.d0
        do 222 k=1,neqn
222       f5(k)=y(k)+ch*(yp(k)+3.d0*f1(k))
        call f(t+3.d0*h/8.d0,f5,f2)
        ch=h/2197.d0
        do 223 k=1,neqn
223       f5(k)=y(k)+ch*(1932.d0*yp(k)+(7296.d0*f2(k)-7200.d0*f1(k)))
        call f(t+12.d0*h/13.d0,f5,f3)
        ch=h/4104.d0
        do 224 k=1,neqn
224       f5(k)=y(k)+ch*((8341.d0*yp(k)-845.d0*f3(k))+
     1          (29440.d0*f2(k)-32832.d0*f1(k)))
        call f(t+h,f5,f4)
        ch=h/20520.d0
        do 225 k=1,neqn
225       f1(k)=y(k)+ch*((-6080.d0*yp(k)+(9295.d0*f3(k)-
     1          5643.d0*f4(k)))+(41040.d0*f1(k)-28352.d0*f2(k)))
        call f(t+h/2.d0,f1,f5)
        ch=h/7618050.d0
        do 230 k=1,neqn
230       s(k)=y(k)+ch*((902880.d0*yp(k)+(3855735.d0*f3(k)-
     1      1371249.d0*f4(k)))+(3953664.d0*f2(k)+277020.d0*f5(k)))
        return
        end







